Subject: wishlist: packaging of SBCL sources; recording of source-definitions for lisp forms
From: Sean Champ <[email-masked]>
To: Debian Bug Tracking System <[email-masked]>
Date: Mon, 15 Aug 2005 12:57:24 -0700

Package: sbcl
Version: 1:0.9.3.0-2
Severity: wishlist

[*] Introduction

Today, I was trying to use SLIME's `slime-edit-definition', in order to
learn a bit more about what is defined in SBCL. However, on a number of
forms, when I tried to view their definitions,  SBCL produced messages like

   Error: Source filename not recorded for ...

That was so, on

   (DEFGENERIC STREAM-LINE-COLUMN)
   (METHOD STREAM-LINE-COLUMN (FUNDAMENTAL-CHARACTER-OUTPUT-STREAM))
   
Yet, for 
 
   (METHOD STREAM-LINE-COLUMN (SWANK-BACKEND::SLIME-OUTPUT-STREAM))
 
SBCL is able to determine where that method is defined -- presumably, given
that the sources for that method's definition are available on the local
system, and given that the code would have been compiled with an DEBUG
OPTIMIZE of quality 2 or greater [incidental ref: SBCL manual, Source
Location Availability], and given the nature of it, a method definition,
such that the source location would be recoded, for it.

[*] The Request

I do not mean to ask overmuch, but if there would be an opportunity that the
SBCL sources would be made available in a Debian package, and if SBCL -- in 
its availability with Debian --  would be available as being compiled, with
such an OPTIMIZE DEBUG proclamation that SBCL would record the source
defintions of appropriate forms, then I am sure it would be of help, for
many users of SBCL (at the very least, for our becoming acquainted with the
SBCL source-code)

Though I realize that I may try to address this request, directly upon the
Debian source package for SBCL, yet it might take me some while, as to
produce anything useful of it. Also, I would only be able to address it for
x86 architectures.

Regardless, I have thought that this should be addressed as a wishlist item,
about the Debian SBCL release.

While I realize that it would probably result in some change in the
performance of SBCL, if it would be compiled with such a DEBUG quality as
would be needed for it to record source locations, yet it may be
of use, to who would intend to see the definition of a form, within the SBCL
sources. As such, it may  be of help, towards the continuing development of
SBCL.

[*] Addressing Attendant Concerns

If it would serve to ease any concern about performance, then to have the
matter brought to any reader's attention: Anyone might derive a package for a
particularly optimized SBCL, deriving the package upon the Debian SBCL
packages -- editing the debian/* files, as to adapt the commands for the
compilation, and to adjust package-names, in order to avoid naming conflicts
--  then, of course, running debuild and/or any more of the 
pacakge-buiding tools. 

Hopefully, such would not result in a bewildering array of SBCL packags, but
hey, "what can one say".

Thank you.

-- System Information:
Debian Release: 3.1
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i586)
Kernel: Linux 2.6.11.8
Locale: LANG=en_US, LC_CTYPE=en_US (charmap=ISO-8859-1)

Versions of packages sbcl depends on:
ii  common-lisp-controller     4.12          This is a Common Lisp source and c
ii  libc6                      2.3.5-3       GNU C Library: Shared libraries an
ii  sbcl-common                1:0.8.21.16-2 Architecture independent files for

-- debconf information excluded